<?php

/************************************************************************/
/* PHP-NUKE: Web Portal System                                          */
/* Module for 123 flash chat server software                            */
/* ===========================                                          */
/*                                                                      */
/* Copyright (c) 2001-2009 by TopCMM 					                */
/* Daniel Jiang (support@123flashchat.com)          			        */
/* http://www.topcmm.com						                        */
/* http://www.123flashchat.com						                    */
/*									                                    */
/* http://phpnuke.org                                                   */
/*                                                                      */
/************************************************************************/
 if (!defined('MODULE_FILE')) {
 	die ("You can't access this file directly...");
 }
$index = 1;
require_once("mainfile.php");
global $module_name;
$module_name = basename(dirname(__FILE__));
get_lang($module_name);

require_once("modules/$module_name/flashchatconf/config.php");

function chat_checkSlash($path)
{
	if(substr($path,-1,1) != "/" && !empty($path)){
		$path = $path."/";
	}
	return $path;
}

function loginChat()
{
	global $db, $user_prefix, $_GET;

	$LOGIN_SUCCESS = 0;
	$LOGIN_PASSWD_ERROR = 1;
	$LOGIN_NICK_EXIST = 2;
	$LOGIN_ERROR = 3;
	$LOGIN_ERROR_NOUSERID = 4;
	$LOGIN_SUCCESS_ADMIN = 5;
	$LOGIN_NOT_ALLOW_GUEST = 6;
	$LOGIN_USER_BANED = 7;

	$username = isset($_GET['username']) ? trim(htmlspecialchars($_GET['username'])) : '';
	$username = substr(str_replace("\\'", "'", $username), 0, 25);
	$username = str_replace("'", "\\'", $username);
	$password = isset($_GET['password']) ? $_GET['password'] : '';
	
	$sql1 = "SELECT user_password FROM ".$user_prefix."_users WHERE username = '" .$username. "'";		
    $sql2 = "SELECT pwd FROM ".$user_prefix."_authors WHERE aid = '" .$username. "'";
    
    $result1 = $db->sql_query($sql1);
    $result2 = $db->sql_query($sql2);
    
	if ( !$result1 && !$result2){
		echo $LOGIN_ERROR;
		exit;	
	}	
    
    $row1 = $db->sql_fetchrow($result1);
    $row2 = $db->sql_fetchrow($result2);
    
    if(empty($row1) && empty($row2)){
        echo $LOGIN_ERROR_NOUSERID;
		exit;
    }
    
    if(!empty($row1)) {
        if($password == $row1['user_password'] || md5($password) == $row1['user_password']) {
            echo $LOGIN_SUCCESS;
			exit;
        }
    }
    
    if(!empty($row2)) {
        if($password == $row2['pwd'] || md5($password) == $row2['pwd']) {
            echo $LOGIN_SUCCESS_ADMIN;
			exit;
        }
    }
    
    echo $LOGIN_PASSWD_ERROR;
	exit;    	
}

function viewChat()
{   
	include("header.php");
	include("footer.php");
}

function curlRequestRemote($url,$mode)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_TIMEOUT, 3);
    @curl_setopt($ch, CURLOPT_USERAGENT, _USERAGENT_);
    @curl_setopt($ch, CURLOPT_REFERER,_REFERER_);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    if($mode == "0")
    {
        curl_setopt($ch, CURLOPT_HEADER, true);
    }
    $r = curl_exec($ch);
    curl_close($ch);
    if($mode == "0")
    {
        return substr($r,0,17);
    }
    return $r;
}

function getServerHostPortHost($client_location){
	$content = curlRequestRemote($client_location,1);
	if ($content){
		//server port
		preg_match('/init_port=([0-9]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port'] = $matches[1];			        	
        }
        //server port s
		preg_match('/init_port_s=([0-9]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port_s'] = $matches[1];			        	
        }
        //server port h
		preg_match('/init_port_h=([0-9]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port_h'] = $matches[1];			        	
        }
        //server host
		preg_match('/init_host=([a-zA-Z0-9.]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host'] = $matches[1];			        	
        }
        //server host s
		preg_match('/init_host_s=([a-zA-Z0-9.]*)&/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host_s'] = $matches[1];			        	
        }
        //server host h
		preg_match('/init_host_h=([a-zA-Z0-9.]*)&/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host_h'] = $matches[1];			        	
        }
        return $data;
    }else{
        return false;
    }
}   
     
function openChat()
{
	global $userinfo,$swf_file_name,$chat_client_root_path,$room_name,$chat_type,$running_mode,$sitename,$primary_server_host,$primary_server_port,$chat_group,$init_host_h,$init_port_h;
	if($running_mode==1)
    {
	   $clientname = ($chat_server_type != 1 && $chat_type == "flash") ? '123flashchat.swf' : 'htmlchat/123flashchat.html';
       
	   $swf_url = $chat_client_root_path . $clientname ;
       $swf_url.= "?init_host=" . $primary_server_host ;
       $swf_url.= "&init_port=" . $primary_server_port ;        
       $swf_url.= "&init_host_h=" . $init_host_h ;
       $swf_url.= "&init_port_h=" . $init_port_h ;                  
       $swf_url.= "&init_group=" . $chat_group ;
       $swf_url.= "&init_root=" . $chat_client_root_path ;
       $swf_url.= "&init_user=" . rawurlencode($userinfo['username']) . "&init_password=" . rawurlencode($userinfo['user_password']) ;
    } 
    else if ($running_mode==2) 
    {
       $serverinfo = getServerHostPortHost($chat_client_root_path); 
       
       $clientname = ($chat_type == "flash") ? '123flashchat.swf' : 'htmlchat/123flashchat.html';
       
       $room_name = ($chat_group != '') ? $chat_group . "/" : '' ;
       
	   $chat_client_root_path = ($chat_client_root_path != '') ? "&init_root=" . chat_checkSlash($chat_client_root_path) : "" ;
       
	   $swf_url = "http://" . $primary_server_host . "/" . $room_name . $clientname ;
       $swf_url.= "?init_host=" . $primary_server_host ;
       $swf_url.= "&init_port=" . $primary_server_port ;
       $swf_url.= "&init_host_s=" . (isset($serverinfo['fc_server_host_s']) ? $serverinfo['fc_server_host_s'] : "");
       $swf_url.= "&init_port_s=" . (isset($serverinfo['fc_server_port_s']) ? $serverinfo['fc_server_port_s'] : "");
       $swf_url.= "&init_host_h=" . (isset($serverinfo['fc_server_host_h']) ? $serverinfo['fc_server_host_h'] : "");
       $swf_url.= "&init_port_h=" . (isset($serverinfo['fc_server_port_h']) ? $serverinfo['fc_server_port_h'] : "");
       $swf_url.= "&init_group=" . $chat_group ;
       $swf_url.= $chat_client_root_path;
       $swf_url.= "&init_user=" . rawurlencode($userinfo['username']) . "&init_password=" . rawurlencode($userinfo['user_password']) ;
	}
    
    //if (isset($_COOKIE['fusion_user']))
    if ($running_mode == 3) {
	echo '
<html>
<head>
<title>Chat Room - Powered by 123FlashChat</title>
</head>
<style type="text/css">
<!--
BODY {	margin:0;}
-->
</style>
<body bgcolor="#FFFFFF">
<!-- 123FLASHCHAT FREE CHAT ROOM CODE BEGIN -->
<link rel="stylesheet" href="./style_images/css_1.css" type="text/css" />
<div id="topcmm_123flashchat" style="width:728px;height:20;margin:0">
<table width="728"><tr>
<td class="menu" align="right">
<a href="http://www.123flashchat.com/buy.html" target="_blank">Remove Ads</a>&nbsp;|&nbsp;
<a href="http://www.123flashchat.com/admin-demo.html" target="_blank">Admin Panel</a>&nbsp;|&nbsp;
<a href="http://www.123flashchat.com/" target="_blank">Free Flash Chat Server Software</a>
</td>
</tr></table>
</div>
<script language="javascript" src="http://free.123flashchat.com/js.php?room=';
	if ($room_name == '')
		echo rawurlencode($sitename);
	else
		echo rawurlencode($room_name);
	echo '&width=730&height=560"></script>
<!-- 123FLASHCHAT FREE CHAT ROOM CODE END -->
</body>
</html>
';

} else {
	?>
    <html>
    <head>
    <title>Chat</title>
    </head>
    <style type="text/css">
    <!--
    BODY {
    	margin: 0;
    }
    -->
    </style>
    <body bgcolor="#FFFFFF">
    <?php
    	if($chat_type == "html"){
    ?>    
        <iframe width="100%" height="100%" src="<?php echo $swf_url; ?>" id="frame" HSPACE="0" VSPACE="0" frameborder="0"  ></iframe>
    <?php
    	} else {
    ?>          
        <object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0" width=100% height=100%>
        	<param name=movie value="<?php echo $swf_url;?>">
        	<param name=quality value=high>
        	<param name=menu value=false>
        	<param name=scale value=noscale>
        	<embed src="<?php echo $swf_url;?>" 
                   quality=high
        		   pluginspage="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash"
        		   type="application/x-shockwave-flash" 
                   width=100% 
                   height=100%
        	       menu="false" 
                   scale="noscale">
        	</embed> 
        </object>
<?php } ?>        
    </body>
    </html>
<?php
}	
	exit;		
}

switch($_GET['op'])
{
 	case "login":
	loginChat();
	break;
	
	case "chat":
	openChat();
	break;
	
	default:
	openChat();
    break;
}	
?> 
 
